| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
ConstCpPoly Class Reference
Thermodynamic Properties » Species Reference-State Thermodynamic Properties

A constant-heat capacity species thermodynamic property manager class. More...

`#include <ConstCpPoly.h>`

Inheritance diagram for ConstCpPoly:
[legend]

## Detailed Description

A constant-heat capacity species thermodynamic property manager class.

This makes the assumption that the heat capacity is a constant. Then, the following relations are used to complete the specification of the thermodynamic functions for the species.

\[ \hat{c}_p^\circ(T) = \hat{c}_p^\circ(T^\circ) \]

\[ \hat{h}^\circ(T) = \hat{h}^\circ\left(T_0\right) + \hat{c}_p^\circ \left(T-T^\circ\right) \]

\[ \hat{s}^\circ(T) = \hat{s}^\circ(T_0) + \hat{c}_p^\circ \ln{\left(\frac{T}{T^\circ}\right)} \]

This parameterization takes 4 input values \( T^\circ \), \( \hat{h}^\circ(T^\circ) \), \( \hat{s}^\circ(T^\circ) \) and \( \hat{c}_p^\circ(T^\circ) \), see setParameters(). The default value of \( T^\circ \) is 298.15 K; the default value for the other parameters is 0.0.

Definition at line 44 of file ConstCpPoly.h.

## Public Member Functions
| ConstCpPoly (double tlow, double thigh, double pref, const double *coeffs)
| Constructor with all input data.
void | setParameters (double t0, double h0, double s0, double cp0)
| Set ConstCpPoly parameters.
int | reportType () const override
| Returns an integer representing the type of parameterization.
void | updateProperties (const double *tt, double *cp_R, double *h_RT, double *s_R) const override
| Update the properties for this species, given a temperature polynomial.
void | updatePropertiesTemp (const double temp, double *cp_R, double *h_RT, double *s_R) const override
| Compute the reference-state property of one species.
size_t | nCoeffs () const override
| This utility function returns the number of coefficients for a given type of species parameterization.
void | reportParameters (size_t &n, int &type, double &tlow, double &thigh, double &pref, double *const coeffs) const override
| This utility function returns the type of parameterization and all of the parameters for the species.
void | getParameters (AnyMap &thermo) const override
| Store the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.
double | reportHf298 (double *const h298=nullptr) const override
| Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)
void | modifyOneHf298 (const size_t k, const double Hf298New) override
| Modify the value of the 298 K Heat of Formation of one species in the phase (J kmol-1)
void | resetHf298 () override
| Restore the original heat of formation for this species.
Public Member Functions inherited from SpeciesThermoInterpType
| SpeciesThermoInterpType (double tlow, double thigh, double pref)
| SpeciesThermoInterpType (const SpeciesThermoInterpType &b)=delete
SpeciesThermoInterpType & | operator= (const SpeciesThermoInterpType &b)=delete
virtual double | minTemp () const
| Returns the minimum temperature that the thermo parameterization is valid.
virtual void | setMinTemp (double Tmin)
| Set the minimum temperature at which the thermo parameterization is valid.
virtual double | maxTemp () const
| Returns the maximum temperature that the thermo parameterization is valid.
virtual void | setMaxTemp (double Tmax)
| Set the maximum temperature at which the thermo parameterization is valid.
virtual double | refPressure () const
| Returns the reference pressure (Pa)
virtual void | setRefPressure (double Pref)
| Set the reference pressure [Pa].
virtual void | validate (const string &name)
| Check for problems with the parameterization, and generate warnings or throw and exception if any are found.
virtual size_t | temperaturePolySize () const
| Number of terms in the temperature polynomial for this parameterization.
virtual void | updateTemperaturePoly (double T, double *T_poly) const
| Given the temperature T, compute the terms of the temperature polynomial T_poly.
AnyMap | parameters (bool withInput=true) const
| Return the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.
const AnyMap & | input () const
| Access input data associated with the species thermo definition.
AnyMap & | input ()

## Protected Attributes
double | m_t0 = 298.15
| Base temperature.
double | m_cp0_R = 0.0
| Dimensionless value of the heat capacity.
double | m_h0_R = 0.0
| dimensionless value of the enthalpy at t0
double | m_s0_R = 0.0
| Dimensionless value of the entropy at t0.
double | m_logt0 = log(298.15)
| log of the t0 value
double | m_h0_R_orig = 0.0
| Original value of h0_R, restored by calling resetHf298()
Protected Attributes inherited from SpeciesThermoInterpType
double | m_lowT = 0.0
| lowest valid temperature
double | m_highT = 0.0
| Highest valid temperature.
double | m_Pref = 0.0
| Reference state pressure.
AnyMap | m_input

## Additional Inherited Members

## Constructor & Destructor Documentation

## ◆ ConstCpPoly() [1/2]

ConstCpPoly | ( |  | ) |

Definition at line 17 of file ConstCpPoly.cpp.

## ◆ ConstCpPoly() [2/2]

ConstCpPoly | ( | double | tlow,
|  | double | thigh,
|  | double | pref,
|  | const double * | coeffs
| ) |  |

Constructor with all input data.

Parameters

  tlow | Minimum temperature
  thigh | Maximum temperature
  pref | reference pressure (Pa).
  coeffs | Vector of coefficients used to set the parameters for the standard state for species n. Contains 4 parameters in the order of setParameters() arguments.

Definition at line 22 of file ConstCpPoly.cpp.

## Member Function Documentation

## ◆ setParameters()

void setParameters | ( | double | t0,
|  | double | h0,
|  | double | s0,
|  | double | cp0
| ) |  |

Set ConstCpPoly parameters.

Parameters

  t0 | \( T^\circ \) [K]
  h0 | \( \hat{h}^\circ(T^\circ) \) [J/kmol]
  s0 | \( \hat{s}^\circ(T^\circ) \) [J/kmol/K]
  cp0 | \( \hat{c}_p^\circ(T^\circ) \) [J/kmol/K]

Definition at line 29 of file ConstCpPoly.cpp.

## ◆ reportType()

int reportType | ( |  | ) | const
| inline override virtual

Returns an integer representing the type of parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 69 of file ConstCpPoly.h.

## ◆ updateProperties()

void updateProperties | ( | const double * | tt,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| override virtual

Update the properties for this species, given a temperature polynomial.

This method is called with a pointer to an array containing the functions of temperature needed by this parameterization, and three pointers to arrays where the computed property values should be written. This method updates only one value in each array.

The form and length of the Temperature Polynomial may vary depending on the parameterization.

Parameters

  tt | vector of evaluated temperature functions
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Form and Length of the temperature polynomial:

- m_t[0] = tt;

Reimplemented from SpeciesThermoInterpType.

Definition at line 38 of file ConstCpPoly.cpp.

## ◆ updatePropertiesTemp()

void updatePropertiesTemp | ( | const double | temp,
|  | double * | cp_R,
|  | double * | h_RT,
|  | double * | s_R
| ) |  | const
| override virtual

Compute the reference-state property of one species.

Given temperature T in K, this method updates the values of the non- dimensional heat capacity at constant pressure, enthalpy, and entropy, at the reference pressure, of the species.

Parameters

  temp | Temperature (Kelvin)
  cp_R | Vector of Dimensionless heat capacities. (length m_kk).
  h_RT | Vector of Dimensionless enthalpies. (length m_kk).
  s_R | Vector of Dimensionless entropies. (length m_kk).

Reimplemented from SpeciesThermoInterpType.

Definition at line 51 of file ConstCpPoly.cpp.

## ◆ nCoeffs()

size_t nCoeffs | ( |  | ) | const
| inline override virtual

This utility function returns the number of coefficients for a given type of species parameterization.

Reimplemented from SpeciesThermoInterpType.

Definition at line 86 of file ConstCpPoly.h.

## ◆ reportParameters()

void reportParameters | ( | size_t & | index,
|  | int & | type,
|  | double & | minTemp,
|  | double & | maxTemp,
|  | double & | refPressure,
|  | double *const | coeffs
| ) |  | const
| override virtual

This utility function returns the type of parameterization and all of the parameters for the species.

All parameters are output variables

Parameters

  index | Species index
  type | Integer type of the standard type
  minTemp | output - Minimum temperature
  maxTemp | output - Maximum temperature
  refPressure | output - reference pressure (Pa).
  coeffs | Vector of coefficients used to set the parameters for the standard state.

Reimplemented from SpeciesThermoInterpType.

Definition at line 63 of file ConstCpPoly.cpp.

## ◆ getParameters()

void getParameters | ( | AnyMap & | thermo | ) | const
| override virtual

Store the parameters of the species thermo object such that an identical species thermo object could be reconstructed using the newSpeciesThermo() function.

Reimplemented from SpeciesThermoInterpType.

Definition at line 77 of file ConstCpPoly.cpp.

## ◆ reportHf298()

double reportHf298 | ( | double *const | h298 = `nullptr` | ) | const
| override virtual

Report the 298 K Heat of Formation of the standard state of one species (J kmol-1)

The 298K Heat of Formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  h298 | If this is nonnull, the current value of the Heat of Formation at 298K and 1 bar for species m_speciesIndex is returned in h298[m_speciesIndex].

Returns
  the current value of the Heat of Formation at 298K and 1 bar for species m_speciesIndex.

Reimplemented from SpeciesThermoInterpType.

Definition at line 87 of file ConstCpPoly.cpp.

## ◆ modifyOneHf298()

void modifyOneHf298 | ( | const size_t | k,
|  | const double | Hf298New
| ) |  |
| override virtual

Modify the value of the 298 K Heat of Formation of one species in the phase (J kmol-1)

The 298K heat of formation is defined as the enthalpy change to create the standard state of the species from its constituent elements in their standard states at 298 K and 1 bar.

Parameters

  k | Species k
  Hf298New | Specify the new value of the Heat of Formation at 298K and 1 bar

Reimplemented from SpeciesThermoInterpType.

Definition at line 97 of file ConstCpPoly.cpp.

## ◆ resetHf298()

void resetHf298 | ( |  | ) |
| override virtual

Restore the original heat of formation for this species.

Resets changes made by modifyOneHf298().

Reimplemented from SpeciesThermoInterpType.

Definition at line 104 of file ConstCpPoly.cpp.

## Member Data Documentation

## ◆ m_t0

double m_t0 = 298.15
| protected

Base temperature.

Definition at line 99 of file ConstCpPoly.h.

## ◆ m_cp0_R

double m_cp0_R = 0.0
| protected

Dimensionless value of the heat capacity.

Definition at line 101 of file ConstCpPoly.h.

## ◆ m_h0_R

double m_h0_R = 0.0
| protected

dimensionless value of the enthalpy at t0

Definition at line 103 of file ConstCpPoly.h.

## ◆ m_s0_R

double m_s0_R = 0.0
| protected

Dimensionless value of the entropy at t0.

Definition at line 105 of file ConstCpPoly.h.

## ◆ m_logt0

double m_logt0 = log(298.15)
| protected

log of the t0 value

Definition at line 107 of file ConstCpPoly.h.

## ◆ m_h0_R_orig

double m_h0_R_orig = 0.0
| protected

Original value of h0_R, restored by calling resetHf298()

Definition at line 109 of file ConstCpPoly.h.

The documentation for this class was generated from the following files:

- ConstCpPoly.h
- ConstCpPoly.cpp